package net.wanji.common.tool.drools;

import com.alipay.jarslink.api.Module;
import com.googlecode.aviator.runtime.function.AbstractFunction;
import com.googlecode.aviator.runtime.function.FunctionUtils;
import com.googlecode.aviator.runtime.type.AviatorObject;

import java.util.Map;

/**
 * @ClassName AddFunction
 * @Description
 * @Author wanji
 * @Date 2020/8/6 15:10
 * @Version 1.0
 */
public class AddFunction extends AbstractFunction {

    private String actionName;

    private Module module;

    public AddFunction(String actionName, Module module) {
        this.actionName = actionName;
        this.module = module;
    }

    @Override
    public AviatorObject call(Map<String, Object> env, AviatorObject args) {
        return module.doAction(actionName, FunctionUtils.getJavaObject(args, env));
    }

    @Override
    public String getName() {
        return actionName;
    }
}
